function HISTORY(callback) {
    window.dhtmlHistory.create({
        toJSON: function(o) {
                return Object.toJSON(o);
        },
        fromJSON: function(s) {
                return s.evalJSON();
        }
    });
    
    dhtmlHistory.initialize();
//    dhtmlHistory.addListener(callback);

    this.started = false;
    this.callback = callback;
    dhtmlHistory.addListener(this.onHistoryEvent(this));
}

HISTORY.prototype.onHistoryEvent = function(self) {
    return function(newLocation, historyData) {
	if (newLocation == "__startup__") {
	    history.forward();
	    adeiReportError(translate("History is exhausted"));
	}
	
	return self.callback(newLocation, historyData);
    }
}

HISTORY.prototype.GetProps = function() {
    return dhtmlHistory.getCurrentLocation();
}

HISTORY.prototype.Add = function(page, cfg) {
    if (!this.started) {
	dhtmlHistory.add("__startup__", cfg);
	this.started = true;
    }
	
    dhtmlHistory.add(page, cfg);
}

HISTORY.prototype.AddSynonim = function(old_page, new_page) {
    var cfg = historyStorage.get(old_page);
    
    if (cfg) {    
	if (historyStorage.hasKey(new_page))
    	    historyStorage.remove(new_page);

	historyStorage.put(new_page, cfg);
    }
}
